- Main Page
- Related Pages
- Modules
- Namespaces
- Classes
- Files
- Directories
- Examples

- Class List
- Class Hierarchy
- Class Members

Public Member Functions

# SurfaceSmoother Class Reference

This reference page is linked to from the following overview topics: Scene Graph, Smoothing and Limit Surfaces, Writing Plug-ins.

Search for all occurrences

## Detailed Description

This is an interface for a SurfaceSmoother object, which is responsible to provide information about the limit surface of a mesh.

Mudbox uses this object to obtain information about the limit surface without actually calculating additional subdivision levels for the meshes. This limit surface is used during map extraction. If you need to control the algorithm by which this limit surface is calculated, you can override this class in a plug-in, and replace Mudbox's version, which is in the plugin called "CCSurfaceSmoother". To create your own:

1. Write a plug-in that defines your own class derived from SurfaceSmoother.

2. Delete the existing CCSurfaceSmoother plugin, and copy yours into the plug-in folder.

On OSX, this plugin is found in the Mudbox module, under Contents>MacOS>plugins. On the PC, it is found in the work dir folder, under "plugins"

Definition at line 1133 of file mesh.h.

`#include <mesh.h>`

Inheritance diagram for SurfaceSmoother:
[legend]

List of all members.

## Public Member Functions
virtual Vector | SmoothPosition (unsigned int iFaceIndex, double fUCoordinate, double fVCoordinate, bool bConsiderCrease=true, bool bConsiderHarden=true) const
| This function must return the position of a point on the surface.
virtual Vector | SmoothNormal (unsigned int iFaceIndex, double fUCoordinate, double fVCoordinate, bool bConsiderCrease=true, bool bConsiderHarden=true) const
| This function must return the surface nomal of a point on the surface.
virtual Vector | SmoothTextureCoordinate (unsigned int iFaceIndex, double fUCoordinate, double fVCoordinate) const
| This function must return the smoothed texture coordinate on the surface.
virtual Base | SmoothTangent (unsigned int iFaceIndex, double fUCoordinate, double fVCoordinate) const
| This function must return the smoothed tangent base on the surface.

## Member Function Documentation

virtual Vector SmoothPosition | ( | unsigned int | iFaceIndex,
|  | double | fUCoordinate,
|  | double | fVCoordinate,
|  | bool | bConsiderCrease = `true`,
|  | bool | bConsiderHarden = `true`
| ) |  | const `[virtual]`

Search for all occurrences

This function must return the position of a point on the surface.

Parameters:

  [in] | iFaceIndex | Index of the face which contains the surface point
  [in] | fUCoordinate | Location in U direction of the point inside the face (must be within 0-1)
  [in] | fVCoordinate | Location in V direction of the point inside the face (must be within 0-1)
  [in] | bConsiderCrease | When the parameter is true, the returned pos will be on the limit surface account for the creasing edges.
  [in] | bConsiderHarden | When the parameter is true, the returned pos will be on the limit surface account for the hard edges.

virtual Vector SmoothNormal | ( | unsigned int | iFaceIndex,
|  | double | fUCoordinate,
|  | double | fVCoordinate,
|  | bool | bConsiderCrease = `true`,
|  | bool | bConsiderHarden = `true`
| ) |  | const `[virtual]`

Search for all occurrences

This function must return the surface nomal of a point on the surface.

Parameters:

  [in] | iFaceIndex | Index of the face which contains the surface point
  [in] | fUCoordinate | Location in U direction of the point inside the face (must be within 0-1)
  [in] | fVCoordinate | Location in V direction of the point inside the face (must be within 0-1)
  [in] | bConsiderCrease | When the parameter is true, the returned normal will be on the limit surface account for the creasing edges.
  [in] | bConsiderHarden | When the parameter is true, the returned normal will be on the limit surface account for the hard edges.

virtual Vector SmoothTextureCoordinate | ( | unsigned int | iFaceIndex,
|  | double | fUCoordinate,
|  | double | fVCoordinate
| ) |  | const `[virtual]`

Search for all occurrences

This function must return the smoothed texture coordinate on the surface.

Parameters:

  [in] | iFaceIndex | Index of the face which contains the surface point
  [in] | fUCoordinate | Location in U direction of the point inside the face (must be within 0-1)
  [in] | fVCoordinate | Location in V direction of the point inside the face (must be within 0-1)

virtual Base SmoothTangent | ( | unsigned int | iFaceIndex,
|  | double | fUCoordinate,
|  | double | fVCoordinate
| ) |  | const `[virtual]`

Search for all occurrences

This function must return the smoothed tangent base on the surface.

Parameters:

  [in] | iFaceIndex | Index of the face which contains the surface point
  [in] | fUCoordinate | Location in U direction of the point inside the face (must be within 0-1)
  [in] | fVCoordinate | Location in V direction of the point inside the face (must be within 0-1)

The documentation for this class was generated from the following file:

- Mudbox/mesh.h

SurfaceSmoother SurfaceSmoother SurfaceSmoother SurfaceSmoother SurfaceSmoother SurfaceSmoother SurfaceSmoother SurfaceSmoother SurfaceSmoother SurfaceSmoother
SurfaceSmoother SurfaceSmoother SurfaceSmoother SurfaceSmoother SurfaceSmoother SurfaceSmoother SurfaceSmoother SurfaceSmoother SurfaceSmoother SurfaceSmoother